module Global
(
  module Global,
  module Var
)
where


import System.IO.Unsafe
import Var
import App


class (Show l, Bounded l, Ix l) => AbstrRef l r where

  globalEnv
    :: l -> r


instance (Show (Var a), Bounded (Var a), Ix (Var a)) => AbstrRef (Var a) (IORef a) where

  globalEnv
    = unsafePerformIO newEnv


readGlobal
--   :: (Show (Var a), Bounded (Var a), Ix (Var a))
  :: (AbstrRef (Var a) (IORef a))
  => Var a -> IO a
readGlobal x
  = globalEnv # readVar x

writeGlobal
--   :: (Show (Var a), Bounded (Var a), Ix (Var a))
  :: (AbstrRef (Var a) (IORef a))
  => Var a -> a -> IO ()
writeGlobal x val
  = globalEnv # writeVar x val

modifyGlobal
--   :: (Show (Var a), Bounded (Var a), Ix (Var a))
  :: (AbstrRef (Var a) (IORef a))
  => Var a -> (a -> a) -> IO ()
modifyGlobal a f
  = globalEnv # modifyVar a f

