module Swap.Reader where


import Reader
import Swap.Var


ask
  :: Var Int -> ReaderT (Env Int) IO ()
ask x
  = do
      always $ putStr ("Input the initial value of " ++ show x ++ ": ")
      s <- always $ getLine
      follow $ writeVar x (read s :: Int)

echo
  :: Var Int -> ReaderT (Env Int) IO ()
echo x
  = do
      val <- follow $ readVar x
      always $ putStrLn ("The value of variable  " ++ show x ++ "  is  " ++ show val)


swap
  :: (Var Int , Var Int) -> ReaderT (Env Int) IO ()
swap (x , y)
  = do
      v1 <- follow $ readVar x
      v2 <- follow $ readVar y
      follow $ writeVar x v2
      follow $ writeVar y v1
      

test
  :: IO ()
test
  = newEnv >>=^
    do
      ask X
      echo X
      ask Y
      echo Y
      always $ putStr "Now swapping ... "
      swap (X , Y)
      always $ putStrLn "done."
      echo X
      echo Y


main
  = do
      test

