module Var 
(
  module Var,
  Ix (..),
  IORef
) 
where


import Data.Array
import Data.IORef


data family Var a
  :: *

type Env a
  = Var a -> IORef a


newEnv
  :: (Show (Var a), Bounded (Var a), Ix (Var a))
  => IO (Env a)
newEnv
  = let
      bounds
        = (minBound , maxBound)
      init l
        = newIORef (error (show l ++ ": uninitialized variable"))
    in
    do
      ls <- sequence (map init (range bounds))
      return (listArray bounds ls !)


readVar
  :: Var a -> Env a -> IO a
readVar x env
  = readIORef (env x)

writeVar
  :: Var a -> a -> Env a -> IO ()
writeVar x val env
  = writeIORef (env x) val

modifyVar
  :: Var a -> (a -> a) -> Env a -> IO ()
modifyVar x f env
  = modifyIORef (env x) f

